#!/usr/bin/perl
##############################################################################
# Megabook - Guestbook ADMINISTRATION Script V2.0                            #
# Copyright 2000 Terry Billinger                                             #
# Created 7/2/00                                                             #
# Modified 12/26/00                                                          #
# Available at http://www.militerry.com/megabook/                            #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 Terry Billinger                                             #
#                                                                            #
# This script can be used\modified free of charge as long as you don't       #
# change this header or any other parts that give me credit for writing      #
# this script.  By using this script you agree to indemnify me from any      #
# liability that might arise from its use.  In simple English, if this       #
# script somehow makes your computer run amuck and kill the pope, it's not   #
# my fault.                                                                  #
#                                                                            #
#                                                                            #
# Redistributing\selling the code for this program without prior written     #
# consent is expressly forbidden.                                            #
##############################################################################

# Change the following line from 0 to 1 if you've forgotten your password
# then go to the forgot password screen and click on reset password.
# After your password has been reset, put this number back to 0.
# You can also change $resetpassword to what you want your password to reset
# to.
$forgotpassword = 0;
$resetpassword = "megabook";


print ("Content-type: text/html\n\n");

# Read in style and setup

&readsetup;

&read;

&checkbanned;

sub	readsetup {

chmod(0666,	"setup.db");
open (SETUP, "setup.db");
@setup = <SETUP>;
close(SETUP);
chmod(0000,	"setup.db");
$setupline = ($setup[0]);
chomp($setupline);
$setupline =~ s/\"/\&#34\;/ig;
($title,$background,$bgcolor,$textcolor,$linkcolor,$vlinkcolor,
$alinkcolor,$homepage,$mailprogram,$datafile,$success,$adminemail,$reverseentries,
$allow_html,$entriesperpage,$maxentries,$mail_you,$guesspass,$nextview,$backview,
$privview,$adminpassword,$uplook,$downlook,$requiredfields,$fontface,$pagesbreaknum,
$yearformat,$dateformat,$timeformat,$timezone,$dateseperator,$altcolor1,$altcolor2,$mail_them,$icqflower) = split(/\|/, $setupline);
@required = split /\s+/, $requiredfields;

open (DATA, "$datafile");
   @data = reverse(<DATA>);
close(DATA);

$totalentries = $#data + 1;

open (BANNEDIP, "banned.txt");
@bannedip = split /\s+/, <BANNEDIP>;
close(BANNEDIP);

open (BADWORDS, "badwords.txt");
@badwords = split /\s+/, <BADWORDS>;
close(BADWORDS);
}

sub	read {

read(STDIN,	$buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach	$pair (@pairs) {
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/\|/&#124\;/g;
		$FORM{$name} = $value;
}

if ($ENV{'QUERY_STRING'}) {

foreach	(split('&', $ENV{'QUERY_STRING'})) {
		s/\+/ /g ;
		($name, $value)= split('=', $_, 2) ;
		$name=~ s/%(..)/chr(hex($1))/ge ;
		$value=~ s/%(..)/chr(hex($1))/ge ;
		$INPUT{$name}.= "\0" if defined($INPUT{$name});  # concatenate multiple vars
		$INPUT{$name}.= $value;
	}
}


foreach	$ip (@bannedip) {
  $ip =~ s/\*//ig;
  if ($ENV{'REMOTE_ADDR'} =~ /^$ip/) {
  print <<IPBANNED;
<html>
<head>
<title>Megabook	V2.0 IP BANNED</title>
</head>

<body bgcolor="#FFFFFF" text="#000000" topmargin="0" rightmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<table width="100%" bgcolor="#005070" border="0">
<tr	bgcolor="#005070">
  <td height="22" width="100%">
  <font face="Arial, Helvetica" size="2" color="#FFFFFF">
  <b>Megabook V2.0</b>
  </font>
  </td>
</tr>
</table>

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font face="Arial, Helvetica" size=2 color=#FFFFFF>
	<b>Megabook - ERROR - IP BANNED</b>
	</font>
	</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
		<b>Sorry but your IP ($ENV{'REMOTE_ADDR'}) has been banned from accessing this Megabook.</b>
		<p>
		If you feel this is an error, please contact the administrator.
	<p>
	</font>
		</td>
	  </tr>
	</table>
	</td>
  </tr>
</table>
</center>
<p>
<p>
</body>
</html>
IPBANNED
  exit;
  }
}

# Decide what to do

if ($FORM{'action'} eq "login") { &menu; }

## External Delete Post Call
if ($INPUT{'action'} eq "modifypost") { &getextpwd; }
if ($FORM{'action'} eq "modifypost") { &modifypost; }
if (($INPUT{'action'} eq "bannedips") && ($ENV{'HTTP_REFERER'} !~ /$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/)) { &getextpwd; }
if (($INPUT{'action'} eq "bannedips") && ($ENV{'HTTP_REFERER'} =~ /$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/)) { &banips; }
if ($FORM{'action'} eq "bannedips") { &banips; }
if ($FORM{'action'} eq "updateips") { &updateips; }
if (($INPUT{'action'} eq "badwordlist") && ($ENV{'HTTP_REFERER'} !~ /$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/)) { &getextpwd; }
if (($INPUT{'action'} eq "badwordlist") && ($ENV{'HTTP_REFERER'} =~ /$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/)) { &badwords; }
if ($FORM{'action'} eq "badwordlist") { &badwords; }
if (($INPUT{'action'} eq "layouts") && ($ENV{'HTTP_REFERER'} !~ /$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/)) { &getextpwd; }
if (($INPUT{'action'} eq "layouts") && ($ENV{'HTTP_REFERER'} =~ /$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/)) { &layouts; }
if ($FORM{'action'} eq "layouts") { &layouts; }
if ($FORM{'action'} eq "updatewords") { &updatewords; }
if (($FORM{'action'} eq "modify") || ($FORM{'action'} eq "delete")) { &moddel; }
if ($INPUT{'action'} eq "changepass") { &changepass; }
if ($FORM{'action'} eq "savenewpass") { &savenewpass; }
if ($FORM{'action'} eq "savesettings") { &savesettings; }
if ($FORM{'action'} eq "updatelayouts") { &updatelayouts; }
if ($INPUT{'action'} eq "modwindow") { &windowmod($INPUT{'layout'}); }
if ($FORM{'action'} eq "writewindowmod") { &writewindowmod; }
if (($FORM{'action'} eq "resetpass") && ($forgotpassword == 1)) {
   &resetpassword;
}
if (($FORM{'action'} eq "resetpass") && ($forgotpassword == 0)) {
   &forgotpass;
}
if ($INPUT{'forgotpass'} == 1) { &forgotpass; }
else { &getpwd; }

}

sub	getdatetime {

 my($min,$hour,$day,$month,$year,$weekday,$ampm,$zero,@weekdays,@months);
 (undef, $min, $hour, $day, $month, $year, $weekday) = localtime(time);
 @weekdays = ("Sunday","Monday","Tuesday","Wednesday",
			 "Thursday","Friday","Saturday");
 @months = ("January","February","March","April","May","June","July",
		   "August","September","October","November","December");
 # Dates correct through 2097
 if ($year > 97) { $year += 1900; } else { $year += 2000; }
 # Fix Time
 if ($hour > 12) { $hour -= 12; $ampm = "PM"; } else { $ampm = "AM"; }
 if ($hour == 0) { $hour = 12; }
 if ($min < 10) { $zero = "0"; } else { $zero = ""; }
 $time = "$hour:$zero$min $ampm";
 $date = "$months[$month] $day, $year";

}

sub	checkpassword {

 &getdatetime;

 $cryptpassinput = crypt($FORM{'password'}, $FORM{'password'});

		if ($FORM{'password'} eq "") {
				&getpwd;
		}
		elsif ($cryptpassinput ne $adminpassword) {

&top;

print <<LOGINHTML;

<p>

<center>
<table border="0" width="70%">
<tr>
  <td>
  <div class="body">
  Megabook Administration
  </div>
  </td>
</tr>
</table>
</center>

<p>
<p>

<center>
<table border="0" width="70%">
<tr>
<td>
<div class="login">
<form method="POST" action="admin.cgi">
Please enter your password:
<br>
<input type="hidden" name="action" value="login">
<input type="password" class="form" name="password" size="30">
<input type="submit" value="Log In">
<br>
<a href="admin.cgi?forgotpass=1" target="forgotpass">Forgot your password?</a>
<p>
<font color=#FF0000>The password you entered, $FORM{'password'}, is incorrect.</font>
</form>
</div>
</td>
</tr>
</table>
</body>
</html>
LOGINHTML
				if (($guesspass eq "1") && $adminemail) {
			open (MAIL, "|$mailprogram -t");
						print MAIL "To: $adminemail\n";
						print MAIL "From: $adminemail\n";
						print MAIL "Subject: Attempted hack\n\n";
						print MAIL "Someone has tried to guess your password for your\n";
						print MAIL "guestbook!  The following information was logged:\n";
						print MAIL "* Date/Time: $date/$time\n";
						print MAIL "* IP Address: $ENV{'REMOTE_ADDR'}\n";
						print MAIL "* Domain: $ENV{'REMOTE_HOST'}\n";
						print MAIL "* Password: $FORM{'password'}\n";
						close (MAIL);
				}
				exit;
	}
}

sub	resetpassword {

$resetcrypt = crypt($resetpassword, $resetpassword);

chmod(0666,	"setup.db");
open (SETUP, ">setup.db");
print SETUP "$title|$background|$bgcolor|$textcolor|$linkcolor|$vlinkcolor|$alinkcolor|$homepage|$mailprogram|$datafile|$success|$adminemail|$reverseentries|$allow_html|$entriesperpage|$maxentries|$mail_you|$guesspass|$nextview|$backview|$privview|$resetcrypt|$uplook|$downlook|$requiredfields|$fontface|$pagesbreaknum|$yearformat|$dateformat|$timeformat|$timezone|$dateseperator|$altcolor1|$altcolor2|$mail_them|$icqflower";
close(SETUP);
chmod(0000,	"setup.db");

&readsetup;

&top;

print <<RESETPASSWORD;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=100%>
		<table width=100% border=0 cellspacing=0 cellpadding=0>
		<tr>
		<td width=50%>
		<font face="arial, helvetica" size=2 color=#FFFFFF>
	<b>Password Reset</b>
	</font>
	</td>
		<td width=50%>
		<font face="arial, helvetica" size=2 color=#FFFFFF>
	<b><div align=right>Megabook V2.0 Administration</div></b>
	</font>
	</td>
	</tr>
	</table>
	</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600 colspan=2>
	<font face="arial, helvetica" size=2>
	Password has been reset to: <b>megabook</b>
	<p>
	<p>
	<a href="admin.cgi">Back to login</a>.
	</font>
		</td>
	  </tr>
	</table>
	</td>
  </tr>
</table>
</center>
RESETPASSWORD

exit;
}

sub	top {

if ($FORM{'password'}) { $password = $FORM{'password'}; } else { $password = $INPUT{'password'}; }

print <<TOP
<html>
<head>
<script language=javascript>

	<!-- 
		function Modify(layout) {
          window.open("admin.cgi?action=modwindow&layout=" + layout + "&password=$password","privateWin","width=640,height=400,menubar=no,scrollbars=auto,scroll=auto");
       }      // -->

</script>
<title>Megabook	V2.0 Administration</title>
<style type="text/css">
<!--
	.body{font-family: Arial, Helvetica; font-size:33px; color:#000000;}
	.login{font-family: Arial, Helvetica; font-size:12px; color:#000000;}
	.form {font-family: Arial, Helvetica; font-size:12px; color:#000000; background:none; border:1; border-style:solid;)
-->
</style>

</head>

<body bgcolor="#FFFFFF" text="#000000" topmargin="0" rightmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<table width="100%" bgcolor="#005070" border="0">
<tr	bgcolor="#005070">
  <td height="22" width="100%">
  <font face="arial, helvetica" size="2" color="#FFFFFF">
  <b>Megabook V2.0</b>
  </font>
  </td>
</tr>
</table>
TOP
}


sub	getpwd {

&top;

print <<LOGINHTML;

<p>

<center>
<table border="0" width="70%">
<tr>
  <td>
  <div class="body">
Megabook Administration
	</div>
  </td>
</tr>
</table>
</center>

<p>
<p>

<center>
<table border="0" width="70%">
<tr>
<td>
<div class="login">
<form method="POST" action="admin.cgi">
Please enter your password:
<br>
<input type="hidden" name="action" value="login">
<input type="password" class="form" name="password" size="30">
<input type="submit" value="Log In">
<br>
<a href="admin.cgi?forgotpass=1" target="forgotpass">Forgot your password?</a>
</form>
</div>
</td>
</tr>
</table>
</body>
</html>
LOGINHTML
exit;
}


sub	menu {

&checkpassword;

&getdatetime;

&top;


if ($allow_html eq "1") {
$allow_html_temp = "<option value=0>ON<option value=1 selected>OFF</select>\n";
} else {
$allow_html_temp = "<option value=0 selected>ON<option value=1>OFF</select>\n";
}

if ($reverseentries eq "1") {
$reverseentries_temp = "<option value=0>Latest to Earliest (??? - 1)<option value=1 selected>Earliest to Latest (1 - ???)</select>\n";
} else {
$reverseentries_temp = "<option value=0 selected>Latest to Earliest (??? - 1)<option value=1>Earliest to Latest (1 - ???)</select>\n";
}

if ($mail_you eq "1") {
$mail_you_temp = "<option value=0>OFF<option value=1 selected>ON</select>\n";
} else {
$mail_you_temp = "<option value=0 selected>OFF<option value=1>ON</select>\n";
}

if ($mail_them eq "1") {
$mail_them_temp	= "<option value=0>OFF<option value=1 selected>ON</select>\n";
} else {
$mail_them_temp	= "<option value=0 selected>OFF<option value=1>ON</select>\n";
}

if ($guesspass eq "1") {
$guesspass_temp	= "<option value=0>OFF<option value=1 selected>ON</select>\n";
} else {
$guesspass_temp	= "<option value=0 selected>OFF<option value=1>ON</select>\n";
}

$dateformat_temp = "<select class=form name=\"dateformat\"><option value=\"1\">MM-DD-YYYY</option><option value=\"2\">DD-MM-YYYY</option><option value=\"3\">YYYY-MM-DD</option><option value=\"4\">YYYY-DD-MM</option><option value=\"5\">Month DD, YYYY</option><option value=\"6\">Mon DD, YYYY</option></select>";

$dateformat_temp =~ s/value=\"$dateformat\"/value=\"$dateformat\" selected/;

$timeformat_temp = "<select class=form name=\"timeformat\"><option value=\"1\">11:00 PM</option><option value=\"2\">11:00p</option><option value=\"3\">23:00</option></select>";

$timeformat_temp =~ s/value=\"$timeformat\"/value=\"$timeformat\" selected/;

$yearformat_temp = "<select class=form name=\"yearformat\"><option value=\"1\">4-Digit (2001)</option><option value=\"2\">2-Digit (01)</option></select>";

$yearformat_temp =~ s/value=\"$yearformat\"/value=\"$yearformat\" selected/;

$timezone_temp = "<select class=form name=\"timezone\"><option  value=\"-12\">[GMT -12:00] Eniwetok, Kwajalein</option><option  value=\"-11\">[GMT -11:00] Midway Island, Samoa</option><option  value=\"-10\">[GMT -10:00] Hawaii</option><option  value=\"-9.5\">[GMT -09:30]</option><option  value=\"-9\">[GMT -09:00] Alaska</option><option  value=\"-8.5\">[GMT -08:30]</option><option  value=\"-8\">[GMT -08:00] Pacific Time (US \&amp; Canada)<option  value=\"-7\">[GMT -07:00] Mountain Time (US \&amp; Canada)<option  value=\"-6\">[GMT -06:00] Central Time (US \&amp; Canada)<option  value=\"-5\">[GMT -05:00] Eastern Time (US \&amp; Canada)<option  value=\"-4\">[GMT -04:00] Atlantic Time (Canada)<option  value=\"-3.5\">[GMT -03:30] Newfoundland</option><option  value=\"-3\">[GMT -03:00] Brasilia, Buenos Aires</option><option  value=\"-2\">[GMT -02:00] Mid-Atlantic</option><option  value=\"-1\">[GMT -01:00] Azores, Cape Verde Is.</option><option  value=\"0\">[GMT 0:00] Greenwich Mean Time<option  value=\"1\">[GMT +01:00] Western
\&amp; Central Europe</option><option  value=\"2\">[GMT +02:00] Finland, Israel, S. Africa</option><option  value=\"3\">[GMT +03:00] Russia, Saudi Arabia</option><option  value=\"3.5\">[GMT +03:30] Iran</option><option  value=\"4\">[GMT +04:00] Arabian Peninsula</option><option  value=\"4.5\">[GMT +04:30]</option><option  value=\"5\">[GMT +05:00] West Asia</option><option  value=\"5.5\">[GMT +05:30] India</option><option  value=\"6\">[GMT +06:00] Central Asia</option><option  value=\"6.5\">[GMT +06:30]</option><option  value=\"7\">[GMT +07:00] Bangkok, Hanoi, Jakarta</option><option  value=\"8\">[GMT +08:00] China, W. Australia</option><option  value=\"9\">[GMT +09:00] Korea, Japan</option><option  value=\"9.5\">[GMT +09:30] Cen. Australia (Adelaide)</option><option  value=\"10\">[GMT +10:00] E. Australia (Brisbane)</option><option  value=\"10.5\">[GMT +10:30]</option><option  value=\"11\">[GMT +11:00] Central Pacific</option><option  value=\"11.5\">[GMT +11:30]</option><option  value=\"12\">[GMT +12:00] Fiji, New Zealand</option></select>";

$timezone_temp =~ s/value=\"$timezone\"/value=\"$timezone\" selected/;

$requiredfields_temp = "Name:<input type=checkbox value=name name=reqname>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;E-mail:<input type=checkbox value=email name=reqemail>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;URL:<input type=checkbox value=url name=requrl>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ICQ Number:<input type=checkbox value=icq name=reqicq>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Comment:<input type=checkbox value=comment name=reqcomment>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<p>Var 1:<input type=checkbox value=var1 name=reqvar1>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Var 2:<input type=checkbox value=var2 name=reqvar2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Var 3:<input type=checkbox value=var3 name=reqvar3>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Var 4:<input type=checkbox value=var4 name=reqvar4>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Var 5:<input type=checkbox value=var5 name=reqvar5>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Var 6:<input type=checkbox value=var6 name=reqvar6>";

if ($icqflower eq "1") {
$icqflower_temp = "<option value=1 selected>ON</option><option value=0>OFF</option></select>\n";
} else {
$icqflower_temp = "<option value=1>ON</option><option value=0 selected>OFF</option></select>\n";
}

foreach  $req(@required) {
		$requiredfields_temp =~ s/value=$req/value=$req checked/;
}

print <<MENU;
<center>
<p>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="100%" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b><div align=right>Megabook V2.0 Administration</div></b>
	</font>
	</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
	<b>Welcome to Megabook Administration</b>
	<p align="center"><font size="1" face="arial, helvetica">Total Entries: $totalentries</font></p>
	<p>
	<table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td width=50%><font face="arial, helvetica" size=2><b>Server Time: </b>$date $time</font></td><td width=50% align=right></td></tr></table>
		<hr noshade size="1" color=#000000 width="100%">
	<p>
<form method="post">
<input type=hidden name=action value=modifypost>
<input type=hidden name=password value=$FORM{'password'}>
	<table cellpadding=1 cellspacing=1 width=100% border=0>
	<tr bgcolor="#506880"><td width=50%><font color=#FFFFFF size="2" face="arial, helvetica"><b>Menu Areas</b></td><td width=50%><font color=#FFFFFF size="2" face="arial, helvetica"><b>Modify/Delete Entries</b></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50%><font size="2" face="arial, helvetica">
		<ul>
		<li>
		<a href="admin.cgi?action=layouts&password=$FORM{'password'}">Layouts</a>
		</li>
		<li>
		<a href="admin.cgi?action=bannedips&password=$FORM{'password'}">Banned IP List</a>
		</li>
		<li>
		<a href="admin.cgi?action=badwordlist&password=$FORM{'password'}">Bad Word List</a>
		</li>
		<li>
		<a href="admin.cgi?action=changepass">Change Password</a>
		</li>
		</ul>
		</font>
		</td>
		<td width=50%><font size="2" face="arial, helvetica"><b>Entry Number</b><br><input size=20 type=text class="form" name=entryid><p><input type=submit value=Submit></td></tr>
	</table>
	</form>
	<form method="post">
	<input type=hidden name=action value=savesettings>
	<input type=hidden name=password value=$FORM{'password'}>
	<table cellpadding=1 cellspacing=1 width=100% border=0>
	<tr bgcolor="#506880"><td colspan=2><font color=#FFFFFF size="2" face="arial, helvetica"><b>Guestbook Settings</b></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50%><font size="2" face="arial, helvetica"><b>Success URL</b><br><font size=1>This is the location that people will be sent to after successfully signging your guestbook.  You can make it a relative path or a URL.</font></td><td align=right width=50%><input size=22 type=text class="form" name=success value="$success"></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50%><font size="2" face="arial, helvetica"><b>Entries Per Page</b><br><font size=1>Set this to how many entries you would like displayed on a page.  Set to -1 to display all entries on one page.</font></td><td align=right width=50%><input size=5 type=text class="form" name=entriesperpage value="$entriesperpage" maxlength=5></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50%><font size="2" face="arial, helvetica"><b>Maximum Number of Entries</b><br><font size=1>Set this to the maximum number of entries you would like.  Set to -1 for an unlimited number of entries.</font></td><td align=right width=50%><input size=5 type=text class="form" name=maxentries value="$maxentries"></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50%><font size="2" face="arial, helvetica"><b>Page List Length</b><br><font size=1>Set this to the number of pages you would like to be displayed in the [pagelist] tag.  Will automatically be set to 3 if set lower.</font></td><td align=right width=50%><input maxlength=5 size=5 type=text class="form" name=pagesbreaknum value="$pagesbreaknum"></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50%><font size="2" face="arial, helvetica"><b>Entry Order</b><br><font size=1>Set this to the way you would like your entries to be displayed.  Either Latest to Earliest or Earliest to Latest.</font></td><td align=right width=50%><select class="form" name="reverseentries">$reverseentries_temp</td></tr>
	<tr bgcolor="#FFFFFF"><td width=50%><font size="2" face="arial, helvetica"><b>HTML Filter</b><br><font size=1>Enables and disables all HTML including images, links, formatting etc.</font></td><td align=right width=50%><select class="form" name="allow_html">$allow_html_temp</td></tr>
	<tr bgcolor="#EEEEEE"><td width=50%><font size="2" face="arial, helvetica"><b>ICQ Flowers</b><br><font size=1>Enables and disables the display of the ICQ flower indicating online presence when using the [icq] tag.  Otherwise using the [icq] tag will just return the number.</font></td><td align=right width=50%><select class="form" name="icqflower">$icqflower_temp</td></tr>
	<tr bgcolor="#FFFFFF"><td width=100% colspan=2><font size="2" face="arial, helvetica"><b>Required Fields</b><br><font size=1>Check the boxes that you wish to be required fields.<P><center>$requiredfields_temp</center></font></font></td></tr>
	</table>
	<p>
	<table cellpadding=1 cellspacing=1 width=100% border=0>
	<tr bgcolor="#506880"><td colspan=2><font color=#FFFFFF size="2" face="arial, helvetica"><b>Mail Settings</b></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50%><font size="2" face="arial, helvetica"><b>Mail Program</b><br><font size=1>This should be set to the path of sendmail on your server.  Please consult your host for the location.  All the following fields require this field to be filled out.</font></td><td align=right width=50%><input size=22 type=text class="form" name=mailprogram value=$mailprogram></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50%><font size="2" face="arial, helvetica"><b>Your E-mail</b><br><font size=1>Set this to your current e-mail address.  This is required if you wish to receive any e-mail about your guestbook.</font></td><td align=right width=50%><input size=22 type=text class="form" name=adminemail value="$adminemail"></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50%><font size="2" face="arial, helvetica"><b>Mail You on Entry</b><br><font size=1>This feature will send you an e-mail, notifying you that someone signed your guestbook.</font></td><td align=right width=50%><select class="form" name="mail_you">$mail_you_temp</td></tr>
	<tr bgcolor="#FFFFFF"><td width=50%><font size="2" face="arial, helvetica"><b>Mail Signer on Entry</b><br><font size=1>This feature will send a person who signed your guestbook an e-mail.  The content of the e-mail can be setup in the "Layouts" section.</font></td><td align=right width=50%><select class="form" name="mail_them">$mail_them_temp</td></tr>
	<tr bgcolor="#EEEEEE"><td width=50%><font size="2" face="arial, helvetica"><b>Mail You on Password Guess</b><br><font size=1>This feature will send you an e-mail when someone tries to guess your administration password</font></td><td align=right width=50%><select class="form" name="guesspass">$guesspass_temp</td></tr>
	</table>
	<p>
	<table cellpadding=1 cellspacing=1 width=100% border=0>
	<tr bgcolor="#506880"><td colspan=2><font color=#FFFFFF size="2" face="arial, helvetica"><b>Time Settings</b></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50%><font size="2" face="arial, helvetica"><b>Timezone</b><br><font size=1>Change this to your timezone so that when someone signs your guestbook the correct time will be displayed.</font></td><td align=right width=50%>$timezone_temp</td></tr>
	<tr bgcolor="#FFFFFF"><td width=50%><font size="2" face="arial, helvetica"><b>Date Stamp</b><br><font size=1>Set this to the way you would like the date to appear when using the [date] tag.  YYYY=Year, MM=Month, DD=Day, Month=Full Month Name, Mon=Short Month Name.</font></td><td align=right width=50%>$dateformat_temp</td></tr>
	<tr bgcolor="#EEEEEE"><td width=50%><font size="2" face="arial, helvetica"><b>Date Seperator</b><br><font size=1>Set this to what you want to seperate the numeric date stamp's numbers with.  Example: 02/24/00 or 02-24-00.</font></td><td align=right width=50%><input size=22 type=text class="form" name=dateseperator value="$dateseperator"></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50%><font size="2" face="arial, helvetica"><b>Time Stamp</b><br><font size=1>Set this to the way you would like the time to appear when using the [time] tag. Either large letter AM/PM, small letter a/p or 24 hour time.</font></td><td align=right width=50%>$timeformat_temp</td></tr>
	<tr bgcolor="#EEEEEE"><td width=50%><font size="2" face="arial, helvetica"><b>Year Format</b><br><font size=1>Set this to how you would like the year to be displayed.  Either 4 digit or 2 digit.</font></td><td align=right width=50%>$yearformat_temp</td></tr>
	</table>
	<p>
	<center>
	<input type=submit value="Save Changes">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type=reset value="Reset">
	</form>
	<p>
	</font>

		</td>
	  </tr>
	</table>
	</td>
  </tr>
</table>
</center>

</body>
</html>
MENU
exit;
}

sub	forgotpass {

&top;

print <<FORGOTMENU1;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<table border=0 cellspacing=0 cellpadding=0 width=100%>
		<tr>
		<td width=50%>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Forgotten Password</b>
	</font>
		</td>
		<td width=50% align=right>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Megabook V2.0 Administration</b>
	</font>
		</td>
		</tr>
		</table>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
		<b>Forgotten your password?  Just follow these instructions:</b>
	<p>
	<p>
	<ol>
	<li> Open admin.cgi in a text editor.</li>
	<li>Scroll down to the line saying: <b>\$forgotpassword = 0;</b>
	<li>Change this to read: <b>\$forgotpassword = 1;</b></li>
	<li>Upload admin.cgi to the same place and refresh this page and a button should appear below saying reset password.</li>
	<li>Press the button to reset your password to <b>megabook</b>.</li>
	<li>Open admin.cgi again in a text editor.</li>
	<li>Change <b>\$forgotpassword = 1;</b> to <b>\$forgotpassword = 0;</b>.</li>
	<li>Upload admin.cgi again.</li>
	<li>Log into the administration area with the password <b>megabook</b> and change your password.</li>
	</ol>
FORGOTMENU1

if ($forgotpassword >= 1) {
	print "<p><p><form method=POST action=admin.cgi><input type=hidden name=action value=resetpass><input type=\"submit\" value=\"RESET PASSWORD\"></form><p>";
}

print <<FORGOTMENU2;
	<p>
	</font>
		</td>
	  </tr>
	</table>
	</td>
  </tr>
</table>
</center>
<p>
<p>
</body>
</html>
FORGOTMENU2

exit;
}

sub	modifypost {

&checkpassword;

$num = ($FORM{'entryid'} - 1);

if (($num > $#data) || ($num < 0) || ($num =~ /[^0-9]+/)) {

	&top;

print <<INVALIDNUM;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Modify/Delete Post - Invalid Entry Number</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
	<b>The entry number you typed in does not exist.
<form method="POST" action="admin.cgi">
<center>
<input type=hidden name=action value=login>
<input type=hidden name=password value=$FORM{'password'}>
<input type="submit" value="Back To Main Menu">
</b>
</form>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
</center>
</body>
</html>

INVALIDNUM
exit;
} else {

$line = ($data[$num]);
chomp($line);
($name,$private,$email,$url,$comment,$adminreply,$month,$day,$year,$min,$hour,$var1,$var2,$var3,$var4,$var5,$var6,$ip,$browser,$icq)	= split(/\|/, $line);
if ($private eq "priv") {
	$privtemp = "<td width=50%><input type=checkbox name=private value=priv checked></td></tr>";
} else{
	$privtemp = "<td width=50%><input type=checkbox name=private value=priv></td></tr>";
}
	$month++;

&top;

	print <<MODIFYPOST;

<form method="POST">
<input type="hidden" name="num" value="$num">
<center>
<p>
<table border=0 cellspacing=0 cellpadding=0 width="600">
<tr	bgcolor="#000000">
<td>
<table width="100%" cellpadding="3" cellspacing="1" border="0">
<tr	bgcolor=#506880>
<td>
<table border=0 cellspacing=0 cellpadding=0 width=100%>
	<tr>
		<td width=50%>
		<font color=#FFFFFF face="arial, helvetica" size=2>
			<b>Modify Entry Number: $FORM{'entryid'}</b>
		</font>
		</td>
<td	width=50% align=right>
<font color=#FFFFFF face="arial, helvetica" size=2>
<b>Megabook	V2.0 Administration</b>
</font>
</td>
</tr>
</table>
</td>
</tr>
<tr	bgcolor=#95A6C1>
<td	colspan=2>
<table cellpadding=1 cellspacing=1 width=100% border=0>
	<tr bgcolor="#EEEEEE"><td width=50% ><font size="2" face="arial, helvetica"><b>Name:</b></font></td>
		<td width=50%><input type="text" class="form" name="name" size="35" value="$name"></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50% ><font size="2" face="arial, helvetica"><b>E-mail:</b></font></td>
		<td width=50%><input type="text" class="form" name="email" size="35" value="$email"></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50% ><font size="2" face="arial, helvetica"><b>Web Page URL:</b></font></td>
		<td width=50%><input type="text" class="form" name="url" size="35" value="$url"></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50% ><font size="2" face="arial, helvetica"><b>ICQ Number:</b></font></td>
		<td width=50%><input type="text" class="form" name="icq" size="35" value="$icq"></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50% ><font size="2" face="arial, helvetica"><b>Comments:</b></font></font></td>
		<td width=50%><textarea name="comment" class="form" rows="5" cols="30" wrap="soft">$comment</textarea></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50% ><font size="2" face="arial, helvetica"><b>Admin Reply:</b></font></font></td>
		<td width=50%><textarea name="adminreply" class="form" rows="5" cols="30" wrap="soft">$adminreply</textarea></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50% ><font size="2" face="arial, helvetica"><b>Month:</b></font></td>
		<td width=50%><input type="text" class="form" name="month" value="$month"></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50% ><font size="2" face="arial, helvetica"><b>Day:</b></font></td>
		<td width=50%><input type="text" class="form" name="day" value="$day"></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50% ><font size="2" face="arial, helvetica"><b>Year:</b></font></td>
		<td width=50%><input type="text" class="form" name="year" value="$year"></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50% ><font size="2" face="arial, helvetica"><b>Hour:</b></font></td>
		<td width=50%><input type="text" class="form" name="hour" value="$hour"></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50% ><font size="2" face="arial, helvetica"><b>Minute:</b></font></td>
		<td width=50%><input type="text" class="form" name="min" value="$min"></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50% ><font size="2" face="arial, helvetica"><b>IP Addr:</b></font></td>
		<td width=50%><input type="text" class="form" name="ip" size="35" value="$ip"></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50% ><font size="2" face="arial, helvetica"><b>Browser:</b></font></td>
		<td width=50%><input type="text" class="form" name="browser" size="35" value="$browser"></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50% ><font size="2" face="arial, helvetica"><b>Var1:</b></font></td>
		<td width=50%><input type="text" class="form" name="var1" size="35" value="$var1"></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50% ><font size="2" face="arial, helvetica"><b>Var2:</b></font></td>
		<td width=50%><input type="text" class="form" name="var2" size="35" value="$var2"></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50% ><font size="2" face="arial, helvetica"><b>Var3:</b></font></td>
		<td width=50%><input type="text" class="form" name="var3" size="35" value="$var3"></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50% ><font size="2" face="arial, helvetica"><b>Var4:</b></font></td>
		<td width=50%><input type="text" class="form" name="var4" size="35" value="$var4"></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50% ><font size="2" face="arial, helvetica"><b>Var5:</b></font></td>
		<td width=50%><input type="text" class="form" name="var5" size="35" value="$var5"></td></tr>
	<tr bgcolor="#EEEEEE"><td width=50% ><font size="2" face="arial, helvetica"><b>Var6:</b></font></td>
		<td width=50%><input type="text" class="form" name="var6" size="35" value="$var6"></td></tr>
	<tr bgcolor="#FFFFFF"><td width=50% ><font size="2" face="arial, helvetica"><b>Private Message?</b></font></td>
		$privtemp
	<tr bgcolor="#EEEEEE"><td width=50% ><font size="2" face="arial, helvetica"><b>What should I do?</b></font></td>
		<td width=50%><input checked type="radio" name="action" value="modify"><font size="2" face="arial, helvetica"><b>Modify this entry</b></font><br>
		<input type="radio" name="action" value="delete"><font size="2" face="arial, helvetica"><b>Delete this entry</b></font><br>
		<input type="radio" name="action" value="login"><font size="2" face="arial, helvetica"><b>Nothing</b></font></td></tr>
		<input type="hidden" name="password" value="$FORM{'password'}">
	<tr bgcolor="#FFFFFF"><td width=50% align="right"><input type="submit" value=" Do it! "></td>
		<td width=50%><input type="reset"></td></tr></table></td></tr></table></tr></td></table></form></body></html>

MODIFYPOST

exit;
}
}

sub	getextpwd {

&top;

print <<LOGINHTML;

<p>

<center>
<table border="0" width="70%">
<tr>
  <td>
  <div class="body">
 Megabook Administration
  </div>
  </td>
</tr>
</table>
</center>

<p>
<p>

<center>
<table border="0" width="70%">
<tr>
<td>
<div class="login">
<form method="POST" action="admin.cgi">
Please log in to use this feature:
<br>
<input type="hidden" name="action" value="$INPUT{'action'}">
<input type="hidden" name="entryid" value="$INPUT{'entryid'}">
<input type="password" class="form" name="password" size="30">
<input type="submit" value="Log In">
<br>
<a href="admin.cgi?forgotpass=1" target="forgotpass">Forgot your password?</a>
</form>
</div>
</td>
</tr>
</table>
</body>
</html>
LOGINHTML
exit;
}

sub	changepass {

&top;

print <<CHANGEPASS;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Change Password</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
<form method="POST" action="admin.cgi">
<center>
<b>Please Fill Out the Following Fields:
<p>
<input type="hidden" class="form" name="action" value="savenewpass">
<table cellpadding=1 cellspacing=1 width=100% border=0>
<tr	bgcolor="#EEEEEE"><td width=50% align=right><font size="2" face="arial, helvetica"><b>Your Old Password:</b></td><td align=right width=50%><input type="password" class="form" name="oldpassword" size="40"></td></tr>
<tr	bgcolor="#FFFFFF"><td width=50% align=right><font size="2" face="arial, helvetica"><b>Your New Password:</b></td><td align=right width=50%><input type="password" class="form" name="newpassword" size="40"></td></tr>
<tr	bgcolor="#EEEEEE"><td width=50% align=right><font size="2" face="arial, helvetica"><b>Confirm New Password:</b></td><td align=right width=50%><input type="password" class="form" name="confirm" size="40"></td></tr>
</table>
<input type="submit" value="Submit">
</b>
</form>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
</center>
</body>
</html>
CHANGEPASS
exit;
}

sub	savenewpass {

&top;

$cryptoldpass = crypt($FORM{'oldpassword'}, $FORM{'oldpassword'});
$cryptnewpass = crypt($FORM{'newpassword'}, $FORM{'newpassword'});

if ($cryptoldpass ne $adminpassword) {

print <<CHANGEPASS;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Change Password</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
<form method="POST" action="admin.cgi">
<center>
<b>Please Fill Out the Following Fields:
<p>
<input type="hidden" class="form" name="action" value="savenewpass">
<table cellpadding=1 cellspacing=1 width=100% border=0>
<tr	bgcolor="#EEEEEE"><td width=50% align=right><font size="2" face="arial, helvetica"><b>Your Old Password:</b></td><td align=right width=50%><input type="password" class="form" name="oldpassword" size="40"></td></tr>
<tr	bgcolor="#FFFFFF"><td width=50% align=right><font size="2" face="arial, helvetica"><b>Your New Password:</b></td><td align=right width=50%><input type="password" class="form" name="newpassword" size="40"></td></tr>
<tr	bgcolor="#EEEEEE"><td width=50% align=right><font size="2" face="arial, helvetica"><b>Confirm New Password:</b></td><td align=right width=50%><input type="password" class="form" name="confirm" size="40"></td></tr>
</table>
<input type="submit" value="Submit">
<p>
<font color=#FF0000>Incorrect Old Password Entered.  Please Try Again.</font>
</b>
</form>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
</center>
</body>
</html>
CHANGEPASS
exit;
} else {
	if (($FORM{'newpassword'} ne $FORM{'confirm'}) || ($FORM{'newpassword'} eq "")) {

print <<CHANGEPASS;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Change Password</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
<form method="POST" action="admin.cgi">
<center>
<b>Please Fill Out the Following Fields:
<p>
<input type="hidden" class="form" name="action" value="savenewpass">
<table cellpadding=1 cellspacing=1 width=100% border=0>
<tr	bgcolor="#EEEEEE"><td width=50% align=right><font size="2" face="arial, helvetica"><b>Your Old Password:</b></td><td align=right width=50%><input type="password" class="form" name="oldpassword" size="40"></td></tr>
<tr	bgcolor="#FFFFFF"><td width=50% align=right><font size="2" face="arial, helvetica"><b>Your New Password:</b></td><td align=right width=50%><input type="password" class="form" name="newpassword" size="40"></td></tr>
<tr	bgcolor="#EEEEEE"><td width=50% align=right><font size="2" face="arial, helvetica"><b>Confirm New Password:</b></td><td align=right width=50%><input type="password" class="form" name="confirm" size="40"></td></tr>
</table>
<input type="submit" value="Submit">
<p>
<font color=#FF0000>New password and Confirm Password do not match.  Please Try Again.</font>
</b>
</form>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
</center>
</body>
</html>
CHANGEPASS
exit;
} else {

chmod(0666,	"setup.db");
open (SETUP, ">setup.db");
print SETUP "$title|$background|$bgcolor|$textcolor|$linkcolor|$vlinkcolor|$alinkcolor|$homepage|$mailprogram|$datafile|$success|$adminemail|$reverseentries|$allow_html|$entriesperpage|$maxentries|$mail_you|$guesspass|$nextview|$backview|$privview|$cryptnewpass|$uplook|$downlook|$requiredfields|$fontface|$pagesbreaknum|$yearformat|$dateformat|$timeformat|$timezone|$dateseperator|$altcolor1|$altcolor2|$mail_them|$icqflower";
close (SETUP);
chmod(0000,	"setup.db");

&readsetup;

print <<CHANGEPASS;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Change Password</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
	<b>Password has been changed to <font color="#FF0000">$FORM{'newpassword'}</font>.  Please be sure to write this down.
<form method="POST" action="admin.cgi">
<center>
<input type=hidden name=action value=login>
<input type=hidden name=password value=$FORM{'newpassword'}>
<input type="submit" value="Back To Main Menu">
</b>
</form>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
</center>
</body>
</html>
CHANGEPASS
exit;
}
}
}

sub	moddel {

	$FORM{'month'}--;

	if ($FORM{'action'} eq "modify") {
		&checkpassword;
		$line = "$FORM{'name'}|$FORM{'private'}|$FORM{'email'}|$FORM{'url'}|$FORM{'comment'}|$FORM{'adminreply'}|$FORM{'month'}|$FORM{'day'}|$FORM{'year'}|$FORM{'min'}|$FORM{'hour'}|$FORM{'var1'}|$FORM{'var2'}|$FORM{'var3'}|$FORM{'var4'}|$FORM{'var5'}|$FORM{'var6'}|$FORM{'ip'}|$FORM{'browser'}|$FORM{'icq'}\n";
		splice(@data,$FORM{'num'},1,($line));
		$FORM{'num'}++;
		$output = "Entry Number $FORM{'num'} has been Modified.";
	} else {
		splice(@data,$FORM{'num'},1,());
		$FORM{'num'}++;
		$output = "Entry Number $FORM{'num'} has been Deleted.";
	}
	@data = reverse(@data);

	# make it wait if someone else is already signing
	while(1) {
		unless (-e "gbdb.lock") { last; }
	}
	&lockdb;
	open (FILE,">$datafile");
		foreach $line(@data) {
			print FILE "$line";
		}
	close(FILE);
	&unlockdb;

	&readsetup;

	&top;

	print <<CHANGEPASS;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Modify/Delete Entry</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
	<b>$output
<form method="POST" action="admin.cgi">
<center>
<input type=hidden name=action value=login>
<input type=hidden name=password value=$FORM{'password'}>
<input type="submit" value="Back To Main Menu">
</b>
</form>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
</center>
</body>
</html>
CHANGEPASS
exit;
}

sub	lockdb {
	$locktime = (time + 10);

	while (-e "gbdb.lock" && time < $locktime) {
		open (LOCK, ">gbdb.lock");
	}

	sub unlockdb {
	close (LOCK);
	unlink ("gbdb.lock");
	}

}

sub	banips {


if ($FORM{'password'}) { $password = $FORM{'password'}; } else { $password = $INPUT{'password'}; }

if ($ENV{'HTTP_REFERER'} !~ /$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/) {
&checkpassword;
} else {

	&top;

foreach $ip(@bannedip) {
	$ipoutput .= "$ip ";
}

	print <<BANNED;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Banned IP Addresses</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
	<center>

<form method=post action=admin.cgi>
<input type=hidden name=action value=updateips>
<input type=hidden name=password value=$password>
<table cellpadding=1 cellspacing=1 width=100% border=0>
<tr	bgcolor="#EEEEEE"><td width=100%><font size="2" face="arial, helvetica"><b>IP List:<br><center><textarea name=ips cols=60 rows=6 wrap="soft">$ipoutput</textarea></b></td></tr>
<tr	bgcolor="#FFFFFF"><td width=100%><font size="2" face="arial, helvetica"><b><center>Partial IPs can also be banned.  In the format 1.1.* 1.1.1.* etc.</b></td></tr>
<tr	bgcolor="#EEEEEE"><td width=100%><font size="2" face="arial, helvetica"><b><center><input type="submit" value="Update List"></b></td></tr>
</table>
</b>
</form>
<form method=post action=admin.cgi>
<input type=hidden name=action value=login>
<input type=hidden name=password value=$password>
<input type="submit" value="Back To Main Menu">
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
</center>
</body>
</html>
BANNED
exit;
}
}

sub updateips {

&checkpassword;

open (BANNEDIPS, ">banned.txt");
print BANNEDIPS "$FORM{'ips'}";
close (BANNEDIPS);

&readsetup;

&top;

print <<UPDATEIPS;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Banned IP List Updated</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
<b>The banned IP list has been updated and saved.</b>
<center>
<p>
<form method=post action=admin.cgi>
<input type=hidden name=action value=login>
<input type=hidden name=password value=$FORM{'password'}>
<input type=submit value="Back to Main Menu">
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
</body>
</html>
UPDATEIPS

exit;
}

sub	badwords {


if ($FORM{'password'}) { $password = $FORM{'password'}; } else { $password = $INPUT{'password'}; }

if ($ENV{'HTTP_REFERER'} !~ /$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/) {
&checkpassword;
} else {

	&top;

foreach $word(@badwords) {
	$wordoutput .= "$word ";
}

	print <<BANNED;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Banned IP Addresses</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
	<center>

<form method=post action=admin.cgi>
<input type=hidden name=action value=updatewords>
<input type=hidden name=password value=$password>
<table cellpadding=1 cellspacing=1 width=100% border=0>
<tr	bgcolor="#EEEEEE"><td width=100%><font size="2" face="arial, helvetica"><b>Bad Word List:<br><center><textarea name=words cols=60 rows=6 wrap="soft">$wordoutput</textarea></b></td></tr>
<tr	bgcolor="#FFFFFF"><td width=100%><font size="2" face="arial, helvetica"><b><center>All these words will be replaced with stars to filter bad language.</b></td></tr>
<tr	bgcolor="#EEEEEE"><td width=100%><font size="2" face="arial, helvetica"><b><center><input type="submit" value="Update List"></b></td></tr>
</table>
</b>
</form>
<form method=post action=admin.cgi>
<input type=hidden name=action value=login>
<input type=hidden name=password value=$password>
<input type="submit" value="Back To Main Menu">
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
</center>
</body>
</html>
BANNED
exit;
}
}

sub updatewords {

&checkpassword;

open (BADWORDS, ">badwords.txt");
print BADWORDS "$FORM{'words'}";
close (BADWORDS);

&readsetup;

&top;

print <<UPDATEWORDS;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Bad Words List Updated</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
<b>The bad words list has been updated and saved.</b>
<center>
<p>
<form method=post action=admin.cgi>
<input type=hidden name=action value=login>
<input type=hidden name=password value=$FORM{'password'}>
<input type=submit value="Back to Main Menu">
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
</body>
</html>
UPDATEWORDS

exit;
}

sub savesettings {

	&checkpassword;

	chmod(0666, "setup.db");
	open (SETUP, ">setup.db");
	$line = "$title|$background|$bgcolor|$textcolor|$linkcolor|$vlinkcolor|$alinkcolor|$homepage|$FORM{'mailprogram'}|$datafile|$FORM{'success'}|$FORM{'adminemail'}|$FORM{'reverseentries'}|$FORM{'allow_html'}|$FORM{'entriesperpage'}|$FORM{'maxentries'}|$FORM{'mail_you'}|$FORM{'guesspass'}|$nextview|$backview|$privview|$adminpassword|$uplook|$downlook|$FORM{'reqname'} $FORM{'reqemail'} $FORM{'requrl'} $FORM{'reqicq'} $FORM{'reqcomment'} $FORM{'reqvar1'} $FORM{'reqvar2'} $FORM{'reqvar3'} $FORM{'reqvar4'} $FORM{'reqvar5'} $FORM{'reqvar6'}|$fontface|$FORM{'pagesbreaknum'}|$FORM{'yearformat'}|$FORM{'dateformat'}|$FORM{'timeformat'}|$FORM{'timezone'}|$FORM{'dateseperator'}|$altcolor1|$altcolor2|$FORM{'mail_them'}|$FORM{'icqflower'}";
	print SETUP "$line";
	close (SETUP);
	chmod(0000, "setup.db");

	&readsetup;

&top;

print <<SAVESETTINGS;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Guestbook Settings Updated</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
<b>Your guestbook settings have been updated and saved.</b>
<center>
<p>
<form method=post action=admin.cgi>
<input type=hidden name=action value=login>
<input type=hidden name=password value=$FORM{'password'}>
<input type=submit value="Back to Main Menu">
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
</body>
</html>
SAVESETTINGS

exit;
}

sub	layouts {


if ($FORM{'password'}) { $password = $FORM{'password'}; } else { $password = $INPUT{'password'}; }

if ($ENV{'HTTP_REFERER'} !~ /$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/) {
&checkpassword;
} else {

	&top;

open (USERMAIL, "usermail.txt");
while (<USERMAIL>) {
	$_ =~ s/</&#60\;/ig;
	$_ =~ s/>/&#62\;/ig;
push (@usermail,$_);
}
close(USERMAIL);

open (HEADER, "header.txt");
while (<HEADER>) {
	$_ =~ s/</&#60\;/ig;
	$_ =~ s/>/&#62\;/ig;
push (@header,$_);
}
close(HEADER);

open (ENTRY, "entry.txt");
while (<ENTRY>) {
	$_ =~ s/</&#60\;/ig;
	$_ =~ s/>/&#62\;/ig;
push (@entry,$_);
}
close(ENTRY);

open (FOOTER, "footer.txt");
while (<FOOTER>) {
	$_ =~ s/</&#60\;/ig;
	$_ =~ s/>/&#62\;/ig;
push (@footer,$_);
}
close(FOOTER);

open (PREVIEW, "preview.txt");
while (<PREVIEW>) {
	$_ =~ s/</&#60\;/ig;
	$_ =~ s/>/&#62\;/ig;
push (@preview,$_);
}
close(PREVIEW);

open (MISSING, "missing.txt");
while (<MISSING>) {
	$_ =~ s/</&#60\;/ig;
	$_ =~ s/>/&#62\;/ig;
push (@missing,$_);
}
close(MISSING);

	print <<LAYOUT;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="610" bgcolor="#000000">
  <tr>
	<td>
	<table width="610" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=610>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Layouts</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=610>
	<font face="arial, helvetica" size=2>
	<center>

<form method=post action=admin.cgi>
<input type=hidden name=action value=updatelayouts>
<input type=hidden name=password value=$password>
<table cellpadding=1 cellspacing=1 width=100% border=0>
	<tr bgcolor="#506880"><td colspan=4><font color=#FFFFFF size="2" face="arial, helvetica"><b>Layout Settings</b></td></tr>
	<tr bgcolor="#EEEEEE">
		<td width=25%><font size="2" face="arial, helvetica"><b>Website Title</b><br><font size=1>Used with the [title] tag.</font></td><td align=right width=25%><input size=20 type=text class="form" name=title value="$title"></td>
		<td width=25%><font size="2" face="arial, helvetica"><b>Website URL</b><br><font size=1>Used with the [homepage] tag.</font></td><td align=right width=25%><input size=20 type=text class="form" name=homepage value="$homepage"></td>
	</tr>
	<tr bgcolor="#FFFFFF">
		<td width=25%><font size="2" face="arial, helvetica"><b>Background Color</b><br><font size=1>Used with the [bgcolor] tag.</font></td><td align=right width=25%><input size=20 type=text class="form" name=bgcolor value="$bgcolor"></td>
		<td width=25%><font size="2" face="arial, helvetica"><b>Background Image</b><br><font size=1>Used with the [background] tag.</font></td><td align=right width=25%><input size=20 type=text class="form" name=background value="$background"></td>
	</tr>
	<tr bgcolor="#EEEEEE">
		<td width=25%><font size="2" face="arial, helvetica"><b>Text Color</b><br><font size=1>Used with the [textcolor] tag.</font></td><td align=right width=25%><input size=20 type=text class="form" name=textcolor value="$textcolor"></td>
		<td width=25%><font size="2" face="arial, helvetica"><b>Link Color</b><br><font size=1>Used with the [linkcolor] tag.</font></td><td align=right width=25%><input size=20 type=text class="form" name=linkcolor value="$linkcolor"></td>
	</tr>
	<tr bgcolor="#FFFFFF">
		<td width=25%><font size="2" face="arial, helvetica"><b>Visited Link Color</b><br><font size=1>Used with the [vlinkcolor] tag.</font></td><td align=right width=25%><input size=20 type=text class="form" name=vlinkcolor value="$vlinkcolor"></td>
		<td width=25%><font size="2" face="arial, helvetica"><b>Active Link Color</b><br><font size=1>Used with the [alinkcolor] tag.</font></td><td align=right width=25%><input size=20 type=text class="form" name=alinkcolor value="$alinkcolor"></td>
	</tr>
	<tr bgcolor="#EEEEEE">
		<td width=25%><font size="2" face="arial, helvetica"><b>Alt Color 1</b><br><font size=1>Used with the [alternate] tag.</font></td><td align=right width=25%><input size=20 type=text class="form" name=altcolor1 value="$altcolor1"></td>
		<td width=25%><font size="2" face="arial, helvetica"><b>Alt Color 2</b><br><font size=1>Used with the [alternate] tag.</font></td><td align=right width=25%><input size=20 type=text class="form" name=altcolor2 value="$altcolor2"></td>
	</tr>
	<tr bgcolor="#FFFFFF">
		<td width=25%><font size="2" face="arial, helvetica"><b>Next Link</b><br><font size=1>Used with the [next] tag.Use [num] for number of entries.</font></td><td align=right width=25%><input size=20 type=text class="form" name=nextview value="$nextview"></td>
		<td width=25%><font size="2" face="arial, helvetica"><b>Back Link</b><br><font size=1>Used with the [back] tag.Use [num] for number of entries.</font></td><td align=right width=25%><input size=20 type=text class="form" name=backview value="$backview"></td>
	</tr>
	<tr bgcolor="#EEEEEE">
		<td width=25%><font size="2" face="arial, helvetica"><b>Private Link</b><br><font size=1>Used when someone leaves a private entry.</font></td><td align=right width=25%><input size=20 type=text class="form" name=privview value="$privview"></td>
		<td width=25%><font size="2" face="arial, helvetica"><b>Font Face</b><br><font size=1>Used with the [font] tag.</font></td><td align=right width=25%><input size=20 type=text class="form" name=fontface value="$fontface"></td> 
	</tr>
	<tr bgcolor="#FFFFFF">
		<td width=25%><font size="2" face="arial, helvetica"><b>Up Entry Link</b><br><font size=1>Used with the [up] tag.</font></td><td align=right width=25%><input size=20 type=text class="form" name=uplook value="$uplook"></td>
		<td width=25%><font size="2" face="arial, helvetica"><b>Down Entry Link</b><br><font size=1>Used with the [down] tag.</font></td><td align=right width=25%><input size=20 type=text class="form" name=downlook value="$downlook"></td>
	</tr>
</table>
<p>
<table cellpadding=1 cellspacing=1 width=100% border=0>
	<tr bgcolor="#506880"><td><font color=#FFFFFF size="2" face="arial, helvetica"><b>E-Mail Layouts</b></td></tr>
	<tr bgcolor="#EEEEEE"><td width=100%><font size="2" face="arial, helvetica"><b>E-Mail to User After Signing</b><br><center><textarea name=usermail cols=60 rows=6 wrap="soft">@usermail</textarea><br>
    <select name=bbbb>
	    <option value="">------ ACTIVE E-MAIL TAGS ------</option>
	    <option value="">[name] - Name</option>
		<option value="">[url] - Website URL</option>
		<option value="">[email] - Email Address</option>
		<option value="">[icq] - ICQ Number</option>
		<option value="">[comment] - Comment</option>
		<option value="">[ip] - IP Address</option>
		<option value="">[browser] - Browser Name</option>
		<option value="">[var1] - Variable 1</option>
		<option value="">[var2] - Variable 2</option>
		<option value="">[var3] - Variable 3</option>
		<option value="">[var4] - Variable 4</option>
		<option value="">[var5] - Variable 5</option>
		<option value="">[var6] - Variable 6</option>
        <option value="">[date] - Entry Date</option>
        <option value="">[time] - Entry Time</option>
	</select>
	</center></td></tr>
</table>
<p>
<table cellpadding=1 cellspacing=1 width=100% border=0>
	<tr bgcolor="#506880"><td><font color=#FFFFFF size="2" face="arial, helvetica"><b>Guestbook Layouts</b></td></tr>
	<tr bgcolor="#EEEEEE"><td width=100%><font size="2" face="arial, helvetica"><b>Header Layout</b><br><A href=javascript:Modify(1)>Larger Screen</a><br><center><textarea name=header cols=60 rows=6 wrap="soft">@header</textarea><br>
	<select name=aaaa>
		<option value="">------ ACTIVE HEADING TAGS ------</option>
		<option value="">[title] - Website Title</option>
		<option value="">[homepage] - Website Homepage</option>
		<option value="">[bgcolor] - Background Color</option>      
		<option value="">[font] - Font Face</option>
		<option value="">[textcolor] - Text Color</option>
		<option value="">[linkcolor] - Link Color</option>
		<option value="">[vlinkcolor] - Visited Link Color</option>
		<option value="">[alinkcolor] - Active Link Color</option>
		<option value="">[background] - Background Image</option>
		<option value="">[htmlstatus] - HTML Status (on or off)</option>
		<option value="">[totalnum] - Total Number of Entries</option>
		<option value="">[startnum] - Starting Number</option>
		<option value="">[endnum] - Ending Number</option>
		<option value="">[next] - Next Page Link</option>
		<option value="">[back] - Back Page Link</option>
		<option value="">[pagelist] - Page Listings</option>
		<option value="">[pagenum] - Current Page Number</option>
		<option value="">[totalpages] - Total Pages</option>
</select>
	</center></td></tr>
	<tr bgcolor="#FFFFFF"><td width=100%><font size="2" face="arial, helvetica"><b>Entry Layout</b><br><A href=javascript:Modify(2)>Larger Screen</a><br><center><textarea name=entry cols=60 rows=6 wrap="soft">@entry</textarea><br>
    <select name=bbbb>
    <option value="">------ ACTIVE ENTRY TAGS ------</option>
    <option value="">[name] - Name</option>
    <option value="">[url] - Website URL</option>
    <option value="">[email] - Email Address</option>
	<option value="">[icq] - ICQ Number</option>
    <option value="">[up] - Up 1 Entry</option>
    <option value="">[down] - Down 1 Entry</option>
    <option value="">[entrynum] - Entry Number</option>
    <option value="">[comment] - Comment</option>
	<option value="">[adminreply] - Admin's Reply</option>
	<option value="">[ip] - IP Address</option>
	<option value="">[browser] - Browser Name</option>
	<option value="">[var1] - Variable 1</option>
	<option value="">[var2] - Variable 2</option>
	<option value="">[var3] - Variable 3</option>
	<option value="">[var4] - Variable 4</option>
	<option value="">[var5] - Variable 5</option>
	<option value="">[var6] - Variable 6</option>
    <option value="">[date] - Entry Date</option>
    <option value="">[time] - Entry Time</option>
	<option value="">[font] - Font Face</option>
	<option value="">[alternate] - Alternating Colors</option>
	</select>
	</center></td></tr>
	<tr bgcolor="#EEEEEE"><td width=100%><font size="2" face="arial, helvetica"><b>Footer Layout</b><br><A href=javascript:Modify(3)>Larger Screen</a><br><center><textarea name=footer cols=60 rows=6 wrap="soft">@footer</textarea><br>
	<select name=aaaa>
		<option value="">------ ACTIVE FOOTER TAGS ------</option>
		<option value="">[font] - Font Face</option>
		<option value="">[totalnum] - Total Number of Entries</option>
		<option value="">[startnum] - Starting Number</option>
		<option value="">[endnum] - Ending Number</option>
		<option value="">[next] - Next Page Link</option>
		<option value="">[back] - Back Page Link</option>
		<option value="">[pagelist] - Page Listings</option>
		<option value="">[pagenum] - Current Page Number</option>
		<option value="">[totalpages] - Total Pages</option>
	</select>
	</center></td></tr>
	<tr bgcolor="#FFFFFF"><td width=100%><font size="2" face="arial, helvetica"><b>Preview Layout</b><br><A href=javascript:Modify(4)>Larger Screen</a><br><center><textarea name=preview cols=60 rows=6 wrap="soft">@preview</textarea><br>
	<select name=aaaa>
		<option value="">------ ACTIVE PREVIEW TAGS ------</option>
		<option value="">[title] - Website Title</option>
		<option value="">[homepage] - Website Homepage</option>
		<option value="">[bgcolor] - Background Color</option>      
		<option value="">[font] - Font Face</option>
		<option value="">[textcolor] - Text Color</option>
		<option value="">[linkcolor] - Link Color</option>
		<option value="">[vlinkcolor] - Visited Link Color</option>
		<option value="">[alinkcolor] - Active Link Color</option>
		<option value="">[background] - Background Image</option>
	    <option value="">[name] - Name</option>
		<option value="">[url] - Website URL</option>
	    <option value="">[email] - Email Address</option>
		<option value="">[icq] - ICQ Number</option>
	    <option value="">[up] - Up 1 Entry</option>
		<option value="">[down] - Down 1 Entry</option>
	    <option value="">[entrynum] - Entry Number</option>
	    <option value="">[comment] - Comment</option>
		<option value="">[ip] - IP Address</option>
		<option value="">[browser] - Browser Name</option>
		<option value="">[var1] - Variable 1</option>
		<option value="">[var2] - Variable 2</option>
		<option value="">[var3] - Variable 3</option>
		<option value="">[var4] - Variable 4</option>
		<option value="">[var5] - Variable 5</option>
		<option value="">[var6] - Variable 6</option>
	    <option value="">[date] - Entry Date</option>
	    <option value="">[time] - Entry Time</option>
		<option value="">[font] - Font Face</option>
		<option value="">[private] - Private Entry</option>
	</select>
	</center></td></tr>
	<tr bgcolor="#EEEEEE"><td width=100%><font size="2" face="arial, helvetica"><b>Missing Fields Layout</b><br><A href=javascript:Modify(5)>Larger Screen</a><br><center><textarea name=missing cols=60 rows=6 wrap="soft">@missing</textarea><br>
	<select name=aaaa>
		<option value="">------ ACTIVE MISSING FIELDS TAGS ------</option>
		<option value="">[title] - Website Title</option>
		<option value="">[homepage] - Website Homepage</option>
		<option value="">[bgcolor] - Background Color</option>      
		<option value="">[font] - Font Face</option>
		<option value="">[textcolor] - Text Color</option>
		<option value="">[linkcolor] - Link Color</option>
		<option value="">[vlinkcolor] - Visited Link Color</option>
		<option value="">[alinkcolor] - Active Link Color</option>
		<option value="">[background] - Background Image</option>
	    <option value="">[name] - Name</option>
		<option value="">[url] - Website URL</option>
	    <option value="">[email] - Email Address</option>
		<option value="">[icq] - ICQ Number</option>
	    <option value="">[comment] - Comment</option>
		<option value="">[var1] - Variable 1</option>
		<option value="">[var2] - Variable 2</option>
		<option value="">[var3] - Variable 3</option>
		<option value="">[var4] - Variable 4</option>
		<option value="">[var5] - Variable 5</option>
		<option value="">[var6] - Variable 6</option>
		<option value="">[font] - Font Face</option>
		<option value="">[private] - Private Entry</option>
	</select>
	</center></td></tr>
	
</table>
<input type=submit value="Save Settings">
</form>
<form method=post action=admin.cgi>
<input type=hidden name=action value=login>
<input type=hidden name=password value=$password>
<input type="submit" value="Back To Main Menu">
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
</center>
</body>
</html>
LAYOUT
exit;
}
}

sub windowmod {
	
	($file) = @_;

	if ($FORM{'password'}) { $FORM{'password'} = $FORM{'password'}; } else { $FORM{'password'} = $INPUT{'password'}; }

	&checkpassword;

	if ($file == 1) {
		$workingfile = "header";
	} 
	elsif ($file == 2) {
		$workingfile = "entry";
	}
	elsif ($file == 3) {
		$workingfile = "footer";
	}
	elsif ($file == 4) {
		$workingfile = "preview";
	}
	elsif ($file == 5) { 
		$workingfile = "missing"; 
	} else { $workingfile = ""; }
	
	open (FILE, "$workingfile.txt");
		while (<FILE>) {
			$_ =~ s/</&#60\;/ig;
			$_ =~ s/>/&#62\;/ig;
			push (@file,$_);
		}
	close(FILE);


	&top;

print <<WINDOWLAYOUT;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="610" bgcolor="#000000">
  <tr>
	<td>
	<table width="610" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=610>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Layouts - Currently Modifying: $workingfile.txt</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=610>
	<font face="arial, helvetica" size=2>
	<center>

<form method=post action=admin.cgi>
<input type=hidden name=action value=writewindowmod>
<input type=hidden name=password value=$password>
<input type=hidden name=file value=$workingfile>
<font size="2" face="arial, helvetica"><center><textarea name=layout cols=70 rows=15 wrap="soft">@file</textarea>
<br>
<input type=submit value="Save Changes">
</form>
</body>
</html>
WINDOWLAYOUT

	exit;
}

sub writewindowmod {

	&checkpassword;

	$file = $FORM{'file'};

	open (FILE, ">$file.txt") or die "Oops";
		print FILE "$FORM{'layout'}";
	close (FILE);

	&top;

print <<WINDOWSAVE;
<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font face="Arial, Helvetica" size=2 color=#FFFFFF>
	<b>Megabook - $file.txt saved.</b>
	</font>
	</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
		<b>Layout file $file.txt has been saved.</b>
		<p>
		Please click the refresh button on your browser.
	<p>
	</font>
		</td>
	  </tr>
	</table>
	</td>
  </tr>
</table>
</center>
<p>
<p>
</body>
</html>
WINDOWSAVE

exit;
}

sub updatelayouts {

&checkpassword;

open (USERMAIL, ">usermail.txt");
	print USERMAIL "$FORM{'usermail'}";
close(USERMAIL);

open (HEADER, ">header.txt");
	print HEADER "$FORM{'header'}";
close(HEADER);

open (ENTRY, ">entry.txt");
	print ENTRY "$FORM{'entry'}";
close(ENTRY);

open (FOOTER, ">footer.txt");
	print FOOTER "$FORM{'footer'}";
close(FOOTER);

open (PREVIEW, ">preview.txt");
	print PREVIEW "$FORM{'preview'}";
close(PREVIEW);

open (MISSING, ">missing.txt");
	print MISSING "$FORM{'missing'}";
close(MISSING);

	chmod(0666, "setup.db");
	open (SETUP, ">setup.db");
	$line = "$FORM{'title'}|$FORM{'background'}|$FORM{'bgcolor'}|$FORM{'textcolor'}|$FORM{'linkcolor'}|$FORM{'vlinkcolor'}|$FORM{'alinkcolor'}|$FORM{'homepage'}|$mailprogram|$datafile|$success|$adminemail|$reverseentries|$allow_html|$entriesperpage|$maxentries|$mail_you|$guesspass|$FORM{'nextview'}|$FORM{'backview'}|$FORM{'privview'}|$adminpassword|$FORM{'uplook'}|$FORM{'downlook'}|$requiredfields|$FORM{'fontface'}|$pagesbreaknum|$yearformat|$dateformat|$timeformat|$timezone|$dateseperator|$FORM{'altcolor1'}|$FORM{'altcolor2'}|$mail_them|$icqflower";
	print SETUP "$line";
	close (SETUP);
	chmod(0000, "setup.db");

	&readsetup;

&top;

print <<SAVESETTINGS;

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600" bgcolor="#000000">
  <tr>
	<td>
	<table width="600" cellpadding="3" cellspacing="1" border="0">
	  <tr bgcolor=#506880>
		<td width=600>
		<font color=#FFFFFF face="arial, helvetica" size=2>
	<b>Guestbook Layout Settings Updated</b>
	</font>
		</td>
	  </tr>
	  <tr bgcolor=#F0F8FF>
		<td width=600>
	<font face="arial, helvetica" size=2>
<b>Your guestbook layout settings have been updated and saved.</b>
<center>
<p>
<form method=post action=admin.cgi>
<input type=hidden name=action value=login>
<input type=hidden name=password value=$FORM{'password'}>
<input type=submit value="Back to Main Menu">
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
</body>
</html>
SAVESETTINGS

exit;

}