#!/usr/bin/perl
##############################################################################
# Megabook - Guestbook VIEW PRIVATE MESSAGES Script V2.0                     # 
# Copyright 2000 Terry Billinger                                             #
# Created 7/2/00                                                             #
# Modified 12/26/00                                                          #
# Available at http://www.militerry.com/megabook/                            #
##############################################################################
# COPYRIGHT NOTICE                                                           #
#                                                                            #
# This script can be used/modified so long as this header and any parts      #
# of the program which give credit remain intact.  By using this program,    #
# you indemnify the creators from any liability that may arise from its use. #
#                                                                            #
# Redistributing/selling the code for this program is strictly forbidden     #
# without prior written consent.									         #
##############################################################################

print ("Content-type: text/html\n\n");

# Reads in style and setup

chmod(0666, "setup.db");
open (SETUP, "setup.db");
@setup = <SETUP>;
close(SETUP);
chmod(0000, "setup.db");
$setupline = ($setup[0]);
chomp($setupline);
($title,$background,$bgcolor,$textcolor,$linkcolor,$vlinkcolor,
$alinkcolor,$homepage,$mailprogram,$datafile,$success,$adminemail,$reverseentries,
$allow_html,$entriesperpage,$maxentries,$mail_you,$guesspass,$nextview,$backview,
$privview,$adminpassword,$uplook,$downlook,$requiredfields,$fontface,$pagesbreaknum,
$yearformat,$dateformat,$timeformat,$timezone,$dateseperator,$altcolor1,$altcolor2,$mail_them,$icqflower) = split(/\|/, $setupline);


# Get guestbook entries

open (DATA, "$datafile");
@data = reverse(<DATA>);
close(DATA);

if ($ENV{'QUERY_STRING'}) {

foreach (split('&', $ENV{'QUERY_STRING'})) {
        s/\+/ /g ;
        ($name, $value)= split('=', $_, 2) ;
        $name=~ s/%(..)/chr(hex($1))/ge ;
        $value=~ s/%(..)/chr(hex($1))/ge ;
        $INPUT{$name}.= "\0" if defined($INPUT{$name}) ;  # concatenate multiple vars
        $INPUT{$name}.= $value ;
    }
}

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $value =~ s/\s/ /g;
        $value =~ s/<([^>]|\n)*>//g;
        $value =~ s/<//g;
        $value =~ s/>//g;
        $FORM{$name} = $value;
}

# Decide what to do

if ($FORM{'action'} eq "view") { &view; }
if ($FORM{'action'} eq "viewip") {&viewip; }
if ($FORM{'action'} eq "banip") { &banip; }
else { &getpwd; }

sub getpwd {

print <<GETPASS;

<html><head><title>LOGIN</title></head><body bgcolor=FFFFFF>
<table border=0 cellpadding=5 cellspacing=0 width=100% height=100%>
<tr><td align=middle valign=middle>
<form method=POST>
GETPASS

if ($INPUT{'privateip'} eq "1") {
   print "<input type=hidden name=action value=viewip>\n";
} else {
   print "<input type=hidden name=action value=view>\n";
}

print <<GETPASS2;
<input type=hidden name=entryid value=$INPUT{'entryid'}>
<table border=0 cellpadding=3 cellspacing=0>
<tr>
   <td>
   <font face=arial size=1>Please enter admin password:</td>
   <td><input type=password size=8 name=password></td>
</tr>
<tr>
   <td></td>
   <td>
   <input type=submit value=View></td>
</tr>
</table>
</td>
</tr>
</table>
GETPASS2
}

sub checkpassword {

 $cryptpassinput = crypt($FORM{'password'}, $FORM{'password'});

	if ($cryptpassinput ne $adminpassword) {
	print "<html><head><title>$title - View Private Message - Bad password</title></head>\n";
                print "<body text=#000000 bgcolor=#ffffff>";
                print "<h1>Bad Password</h1><br>\n";
                print "The password you entered, $FORM{'password'}, is incorrect.\n";
		exit;
	}
}

sub view {

        &checkpassword;
	$num = ($FORM{'entryid'} - 1);
	$line = ($data[$num]);
	chomp($line);
        ($name,$private,$email,$url,$comment,$adminreply,$month,$day,$year,$min,$hour,$var1,$var2,$var3,$var4,$var5,$var6,$ip,$browser,$icq) = split(/\|/, $line);

	if ($private ne "priv") {
		print "<html><title>Not a private entry</title>\n";
		print "<body text=#000000 bgcolor=#ffffff>\n";
		print "The entry you are trying to view is not a private entry.\n";
		print "</body></html>\n";
		exit;
	} else {
		print "<html><title>Private entry #$FORM{'entryid'}</title>";
		print "<body text=#000000 bgcolor=#ffffff>";
		print "<table width=100% height=100%>";
		print "<tr>";
		print "<td align=middle valign=middle>";
		print "<table border=0 cellpadding=0 cellspacing=0>";
		print "<tr>";
		print "<td width=280>";
		print "<font face=arial size=1>$comment<p>";
		print "<a href=javascript:self.close();>close</a>";
		print "</td></tr></table></td></tr></table></body></html>";
		exit;
	}
}

sub viewip {

        &checkpassword;
	$num = ($FORM{'entryid'} - 1);
	$line = ($data[$num]);
	chomp($line);
        ($name,$private,$email,$url,$comment,$adminreply,$month,$day,$year,$min,$hour,$var1,$var2,$var3,$var4,$var5,$var6,$ip,$browser,$icq) = split(/\|/, $line);
	print "<html><title>Private IP for entry #$FORM{'entryid'}</title>";
	print "<body text=#000000 bgcolor=#ffffff>";
	print "<table width=100% height=100%>";
	print "<tr>";
	print "<td align=middle valign=middle>";
	print "<table border=0 cellpadding=0 cellspacing=0>";
	print "<tr>";
	print "<td width=280>";
	print "<font face=arial size=1>$ip<p>";
	print "<form method=POST>\n";
	print "<input type=hidden name=action value=banip>\n";
	print "<input type=hidden name=ip value=$ip>\n";
	print "<input type=hidden name=password value=$FORM{'password'}>\n";
	print "<input type=submit value=\"Ban IP\">\n";
	print "</form><p>\n";
	print "<a href=javascript:self.close();>close</a>";
	print "</td></tr></table></td></tr></table></body></html>";
	exit;
}

sub banip {

       &checkpassword;
       open (BANNED, "banned.txt");
	@banned = <BANNED>;
       close(BANNED);
       open (BANNED, ">banned.txt");
	print BANNED "@banned $FORM{'ip'}";
       close(BANNED);
	print "<html><title>$FORM{'ip'} BANNED</title>";
	print "<body text=#000000 bgcolor=#ffffff>";
	print "<table width=100% height=100%>";
	print "<tr>";
	print "<td align=middle valign=middle>";
	print "<table border=0 cellpadding=0 cellspacing=0>";
	print "<tr>";
	print "<td width=280>";
	print "<font face=arial size=1>$FORM{'ip'} has been banned from your guestbook.<p>";
	print "<a href=javascript:self.close();>close</a>";
	print "</td></tr></table></td></tr></table></body></html>";
	exit;
}