#!/usr/bin/perl
##############################################################################
# Megabook - Guestbook SIGNING Script V2.0                                   # 
# Copyright 2000 Terry Billinger                                             #
# Created 7/2/00                                                             #
# Modified 12/26/00                                                          #
# Available at http://www.militerry.com/megabook/                            #
##############################################################################
# COPYRIGHT NOTICE                                                           #
#                                                                            #
# This script can be used/modified so long as this header and any parts      #
# of the program which give credit remain intact.  By using this program,    #
# you indemnify the creators from any liability that may arise from its use. #
#                                                                            #
# Redistributing/selling the code for this program is strictly forbidden     #
# without prior written consent.									         #
##############################################################################

# Reads in style and setup.

chmod(0666, "setup.db");
open (SETUP, "setup.db");
@setup = <SETUP>;
close(SETUP);
chmod(0000, "setup.db");
$setupline = ($setup[0]);
chomp($setupline);
($title,$background,$bgcolor,$textcolor,$linkcolor,$vlinkcolor,
$alinkcolor,$homepage,$mailprogram,$datafile,$success,$adminemail,$reverseentries,
$allow_html,$entriesperpage,$maxentries,$mail_you,$guesspass,$nextview,$backview,
$privview,$adminpassword,$uplook,$downlook,$requiredfields,$fontface,$pagesbreaknum,
$yearformat,$dateformat,$timeformat,$timezone,$dateseperator,$altcolor1,$altcolor2,$mail_them,$icqflower) = split(/\|/, $setupline);


# Get guetsbook entries

open (DATA, "$datafile");
   @data = <DATA>;
close(DATA);

$thisentry = ($#data + 2);

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $value =~ s/\|/&#124\;/g;

        $value =~ s/</&#60;/g;
        $value =~ s/>/&#62;/g;

	# Check for line feeds
 
	$value =~ s/\n\r\n/<p>/sg;
	$value =~ s/\n\n/<p>/sg;
	$value =~ s/\n/<br>/sg;
	$value =~ s/\r//sg;

        $value =~ s/\s/ /g;
        $FORM{$name} = $value;
        }

open (BANNEDIP, "banned.txt");
@bannedip = split /\s+/, <BANNEDIP>;
close(BANNEDIP);

foreach $ip (@bannedip) {
  $ip =~ s/\*//ig;
  if ($ENV{'REMOTE_ADDR'} =~ /^$ip/) {

  print ("Content-type: text/html\n\n");
  print <<IPBANNED;
<html>
<head>
<title>Megabook V2.0 IP BANNED</title>
</head>

<body bgcolor="#FFFFFF" text="#000000" topmargin="0" rightmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<table width="100%" bgcolor="#005070" border="0">
<tr bgcolor="#005070">
  <td height="22" width="100%">
  <font face="Arial" size="2" color="#FFFFFF">
  <b>Megabook V2.0</b>
  </font>
  </td>
</tr>
</table>

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="640" bgcolor="#000000">
  <tr>
    <td>
    <table width="640" cellpadding="3" cellspacing="1" border="0">
      <tr bgcolor=#506880>
        <td width=640>
        <font face=Arial size=2 color=#FFFFFF>
	<b>Megabook Error - IP BANNED</b>
	</font>
	</td>
      </tr>
      <tr bgcolor=#F0F8FF>
        <td width=640>
	<font face=Arial size=2>
        <b>Sorry but your IP ($ENV{'REMOTE_ADDR'}) has been banned from signing this Megabook.</b>
        <p>
        If you feel this is an error, please contact the administrator.
	<p>
	</font>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</center>
<p>
<p>  
</body>
</html>
IPBANNED
  exit;
  }
}


@required = split /\s+/, $requiredfields;

 if (@required) {
   foreach $field (@required) {
     if (!$FORM{$field}) { &missing; }
   }
 }

if ($FORM{'preview'} eq "1") {
   &preview;
}

&gettime;

# Write Data to File
	
splice (@data,0,0,"$FORM{'name'}|$FORM{'private'}|$FORM{'email'}|$FORM{'url'}|$FORM{'comment'}||$mon|$day|$year|$min|$hour|$FORM{'var1'}|$FORM{'var2'}|$FORM{'var3'}|$FORM{'var4'}|$FORM{'var5'}|$FORM{'var6'}|$ENV{'REMOTE_ADDR'}|$ENV{'HTTP_USER_AGENT'}|$FORM{'icq'}\n");
unless ($maxentries <= 0) { while ($#data > $maxentries) { splice(@data,$#data,1); } }
# make it wait if someone else is already signing
        while(1) {
           unless (-e "gbdb.lock") { last; }
        }
        &lockdb;
        open (FILE,">$datafile");
        foreach $line(@data) { 
        print FILE "$line"; 
        }
        close(FILE);
        &unlockdb;

# Mail Admin if Needed
if (($mail_you) && ($adminemail)) {
  &mail_admin;
}

if ($FORM{'email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/ || $FORM{'email'} !~ /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/) {
	$sendemail = "invalid";
} elsif ($mail_them == 1) {
	&mail_them;
}

if ($success) {
  print "Location: $success \n\n";
} else {
  print ("Content-type: text/html\n\n");
  print <<SUCCESS;
<html>
<head>
<title>Megabook V2.0 Entry Added</title>
</head>

<body bgcolor="#FFFFFF" text="#000000" topmargin="0" rightmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<table width="100%" bgcolor="#005070" border="0">
<tr bgcolor="#005070">
  <td height="22" width="100%">
  <font face="Arial" size="2" color="#FFFFFF">
  <b>Megabook V2.0</b>
  </font>
  </td>
</tr>
</table>

<p>
<center>
<table border=0 cellspacing=0 cellpadding=0 width="640" bgcolor="#000000">
  <tr>
    <td>
    <table width="640" cellpadding="3" cellspacing="1" border="0">
      <tr bgcolor=#506880>
        <td width=640>
        <font face=Arial size=2 color=#FFFFFF>
	<b>Megabook Submission Processed</b>
	</font>
	</td>
      </tr>
      <tr bgcolor=#F0F8FF>
        <td width=640>
	<font face=Arial size=2>
        <b>Thank you for adding your entry to the guestbook.</b>
        <p>
        Click your back button on your browser to return to the guestbook.
	<p>
	</font>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</center>
<p>
<p>  
</body>
</html>
SUCCESS
 }
exit;


sub gettime {
 # Create Date Stamp
$timezone = ($timezone * 3600);
($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst) = gmtime(time+$timezone);

#### Fix Y2K
if ($year > 97) { 
   $year += 1900; 
} else { 
   $year += 2000; 
}

if ($min < 10) { 
  $min = "0$min"; 
}

}

sub mail_admin {

&getoldtime;

 open (MAIL, "|$mailprogram -t") || &error("MAIL");
 print MAIL "To: $adminemail\n";
 print MAIL "From: $adminemail\n";
 print MAIL "Subject: Guestbook Entry\n\n";
 print MAIL "The following entry was added to your guestbook:\n\n";
 print MAIL "* Name: $FORM{'name'}\n";
 print MAIL "* Email: $FORM{'email'}\n";
 print MAIL "* URL: $FORM{'url'}\n";
 print MAIL "* ICQ: $FORM{'icq'}\n";
 print MAIL "* Comments: $FORM{'comment'}\n";
 print MAIL "* Time: $time\n";
 print MAIL "* Date: $date\n";
 print MAIL "* VAR1: $FORM{'var1'}\n";
 print MAIL "* VAR2: $FORM{'var2'}\n";
 print MAIL "* VAR3: $FORM{'var3'}\n";
 print MAIL "* VAR4: $FORM{'var4'}\n";
 print MAIL "* VAR5: $FORM{'var5'}\n";
 print MAIL "* VAR6: $FORM{'var6'}\n";
 close (MAIL);
}

sub mail_them {

&getoldtime;

open (USERMAIL, "usermail.txt");
while (<USERMAIL>) {
	$_ =~ s/\[name\]/$FORM{'name'}/ig;
	$_ =~ s/\[url\]/$FORM{'url'}/ig;
	$_ =~ s/\[email\]/$FORM{'email'}/ig;
	$_ =~ s/\[comment\]/$FORM{'comment'}/ig;
	$_ =~ s/\[icq\]/$FORM{'icq'}/ig;
	$_ =~ s/\[var1\]/$FORM{'var1'}/ig;
	$_ =~ s/\[var2\]/$FORM{'var2'}/ig;
	$_ =~ s/\[var3\]/$FORM{'var3'}/ig;
	$_ =~ s/\[var4\]/$FORM{'var4'}/ig;
	$_ =~ s/\[var5\]/$FORM{'var5'}/ig;
	$_ =~ s/\[var6\]/$FORM{'var6'}/ig;
	$_ =~ s/\[time\]/$time/ig;
	$_ =~ s/\[date\]/$date/ig;
	$_ =~ s/\[ip\]/$ENV{'REMOTE_ADDR'}/ig;
	$_ =~ s/\[browser\]/$ENV{'HTTP_USER_AGENT'}/ig;
push (@usermail,$_);
}
close(USERMAIL);

$recipient = $FORM{'email'};

open (MAIL, "|$mailprogram -t") || &error("MAIL");
	print MAIL "To: $recipient\n";
	print MAIL "From: $adminemail\n";
	print MAIL "@usermail";
close(MAIL);
}

sub error {
  my %ERR;
  $ERR{"GET"} = "The script must be called with the POST method.";
  $ERR{"MAIL"} = "An error occurred while sending mail to the site
     administrator.  If this persists, please let them know.";
  my $emsg = $ERR{$_[0]};
  if (!$emsg) {
    $emsg = "The script has suffered an unknown error.";
  }
  print ("Content-type: text/html\n\n");
  print "<html><body bgcolor=#FFFFFF text=#000000>\n";
  print "<h1>Guestbook Error</h1>\n";
  print "$emsg";
  print "</body></html>";
  exit;
}

sub missing {

print ("Content-type: text/html\n\n");

if ($FORM{'private'} eq "priv") {
   $private = "checked"
}

open (MISSINGLAYOUT, "missing.txt");
while (<MISSINGLAYOUT>) {
	$_ =~ s/\[title\]/$title/ig;
	$_ =~ s/\[background\]/$background/ig;
	$_ =~ s/\[bgcolor\]/$bgcolor/ig;
	$_ =~ s/\[font\]/$fontface/ig;
	$_ =~ s/\[textcolor\]/$textcolor/ig;
	$_ =~ s/\[linkcolor\]/$linkcolor/ig;
	$_ =~ s/\[vlinkcolor\]/$vlinkcolor/ig;
	$_ =~ s/\[alinkcolor\]/$alinkcolor/ig;
	$_ =~ s/\[homepage\]/$homepage/ig;
	$_ =~ s/\[name\]/$FORM{'name'}/ig;
	$_ =~ s/\[url\]/$FORM{'url'}/ig;
	$_ =~ s/\[email\]/$FORM{'email'}/ig;
	$_ =~ s/\[icq\]/$FORM{'icq'}/ig;
	$_ =~ s/\[comment\]/$FORM{'comment'}/ig;
	$_ =~ s/\[var1\]/$FORM{'var1'}/ig;
	$_ =~ s/\[var2\]/$FORM{'var2'}/ig;
	$_ =~ s/\[var3\]/$FORM{'var3'}/ig;
	$_ =~ s/\[var4\]/$FORM{'var4'}/ig;
	$_ =~ s/\[var5\]/$FORM{'var5'}/ig;
	$_ =~ s/\[var6\]/$FORM{'var6'}/ig;
	$_ =~ s/\[private\]/$private/ig;
	$_ =~ s/\[font\]/$fontface/ig;
push (@missinglayout,$_);
}
close(MISSINGLAYOUT);

print "@missinglayout";
     exit;
}

sub preview {

print ("Content-type: text/html\n\n");


if ($FORM{'private'} eq "priv") {
    $private = "checked";
} else {
	$private = "";
}

&gettime;
&setuptime;

$up = "<a href=#$upentry style=\"text-decoration: none;\">$uplook</a>";
$down = "<a href=#$downentry style=\"text-decoration: none;\">$downlook</a>";

open (PREVIEWLAYOUT, "preview.txt");
while (<PREVIEWLAYOUT>) {
	$_ =~ s/\[title\]/$title/ig;
	$_ =~ s/\[background\]/$background/ig;
	$_ =~ s/\[bgcolor\]/$bgcolor/ig;
	$_ =~ s/\[font\]/$fontface/ig;
	$_ =~ s/\[textcolor\]/$textcolor/ig;
	$_ =~ s/\[linkcolor\]/$linkcolor/ig;
	$_ =~ s/\[vlinkcolor\]/$vlinkcolor/ig;
	$_ =~ s/\[alinkcolor\]/$alinkcolor/ig;
	$_ =~ s/\[homepage\]/$homepage/ig;
	$_ =~ s/\[name\]/$FORM{'name'}/ig;
	$_ =~ s/\[url\]/$FORM{'url'}/ig;
	$_ =~ s/\[icq\]/$FORM{'icq'}/ig;
	$_ =~ s/\[email\]/$FORM{'email'}/ig;
	$_ =~ s/\[entrynum\]/$thisentry/ig;
	$_ =~ s/\[comment\]/$FORM{'comment'}/ig;
	$_ =~ s/\[var1\]/$FORM{'var1'}/ig;
	$_ =~ s/\[var2\]/$FORM{'var2'}/ig;
	$_ =~ s/\[var3\]/$FORM{'var3'}/ig;
	$_ =~ s/\[var4\]/$FORM{'var4'}/ig;
	$_ =~ s/\[var5\]/$FORM{'var5'}/ig;
	$_ =~ s/\[var6\]/$FORM{'var6'}/ig;
	$_ =~ s/\[private\]/$private/ig;
	$_ =~ s/\[time\]/$time/ig;
	$_ =~ s/\[date\]/$date/ig;
	$_ =~ s/\[ip\]/$ENV{'REMOTE_ADDR'}/ig;
	$_ =~ s/\[browser\]/$ENV{'HTTP_USER_AGENT'}/ig;
	$_ =~ s/\[up\]/$up/ig;
	$_ =~ s/\[down\]/$down/ig;
	$_ =~ s/\[font\]/$fontface/ig;
push (@previewlayout,$_);
}
close(PREVIEWLAYOUT);

print "@previewlayout";
exit;
}

sub lockdb {
$locktime = (time + 10);
while (-e "gbdb.lock" && time < $locktime) {
open (LOCK, ">gbdb.lock");
}

sub unlockdb {
close (LOCK);
unlink ("gbdb.lock");
} 
}

sub setuptime {

	$month++;

####### TIME SETUP

#### Time Setups for Time Formats
if ($timeformat <= 2) {
   if ($hour == 0) { 
      $hour = 12; 
   }
   if ($hour > 12) {
      $hour -= 12;
         if ($timeformat == 1) {
           $ampm = " PM"; 
         } else {
           $ampm = "p";
         }
   } else { 
      if ($timeformat == 1) {
        $ampm = " AM";
      } else {
        $ampm = "a";
      }
   }
} else {
	if ($hour < 10) {
	$hour = "0$hour";
	}
   $ampm = "";
}


sub timefix {

if ($day < 10) {
  $day = "0$day";
}

if ($yearformat == 2) { 
   $year -= "2000"; 
   if ($year < 10) { $yearzero = "0"; } else { $yearzero = ""; }
} else {
   $yearzero = "";
}

@months = ("1","2","3","4","5","6","7", "8","9","10","11","12");
$month = @months[$month];
if ($month < 10) { 
  $month = "0$month"; 
}
}

if ($dateformat == 1) {
&timefix;
$date = "$month$dateseperator$day$dateseperator$yearzero$year";
}
if ($dateformat == 2) {
&timefix;
$date = "$day$dateseperator$month$dateseperator$yearzero$year";
}
if ($dateformat == 3) {
&timefix;
$date = "$yearzero$year$dateseperator$month$dateseperator$day";
}
if ($dateformat == 4) {
&timefix;
$date = "$yearzero$year$dateseperator$day$dateseperator$month";
}
if ($dateformat == 5) {
@months = ("January","February","March","April","May","June","July", "August","September","October","November","December");
$month = @months[$month];
$date = "$month $day, $year";

}
if ($dateformat == 6) {
@months = ("Jan","Feb","Mar","Apr","May","Jun","Jul", "Aug","Sep","Oct","Nov","Dec");
$month = @months[$month];
$date = "$month $day, $year";
}

$time = "$hour:$min$ampm";
}

sub getoldtime {

 # Create Date Stamp
 (undef, $min, $hour, $day, $month, $year, $weekday) = localtime(time);
 @months = ("January","February","March","April","May","June","July",
           "August","September","October","November","December");
 # Dates correct through 2097 :)
 if ($year > 97) { $year += 1900; } else { $year += 2000; }  
 # Fix Time
 if ($hour > 12) { $hour -= 12; $ampm = "PM"; } else { $ampm = "AM"; }
 if ($hour == 0) { $hour = 12; }
 if ($min < 10) { $zero = "0"; } else { $zero = ""; }
 $time = "$hour:$zero$min $ampm";
 $date = "$months[$month] $day, $year";
}